<?php

namespace FiloBlu\RuleDayFromBirthday\Api;

use FiloBlu\RuleDayFromBirthday\Api\Data\CustomCouponInterface;
use FiloBlu\Core\Framework\Model\RepositoryInterface;

/**
 * Interface CustomCouponRepositoryInterface
 * @package FiloBlu\RuleDayFromBirthday\Api
 */
interface CustomCouponRepositoryInterface extends RepositoryInterface
{

    /**
     * Save the SalesRule.
     *
     * @param \FiloBlu\RuleDayFromBirthday\Api\Data\CustomCouponInterface $customCoupon
     * @return \FiloBlu\RuleDayFromBirthday\Api\Data\CustomCouponInterface
     * @throws \Magento\Framework\Exception\CouldNotSaveException
     */
    public function save(CustomCouponInterface $customCoupon): CustomCouponInterface;

    /**
     * @param $value
     * @param string $column
     * @return mixed
     */
    public function getByKey($value, string $column);
}
