<?php

declare(strict_types=1);

namespace FiloBlu\RuleDayFromBirthday\Controller\Adminhtml\Promo\Quote;

use FiloBlu\RuleDayFromBirthday\Block\Adminhtml\Promo\Quote\Edit\Tab\Coupons\Grid;
use Magento\Framework\App\Filesystem\DirectoryList;
use Magento\Framework\App\ResponseInterface;
use Magento\SalesRule\Controller\Adminhtml\Promo\Quote;
use Magento\SalesRule\Model\RegistryConstants;

/**
 * @class ExportCouponsXml
 * @package FiloBlu\RuleDayFromBirthday\Controller
 */
class ExportCouponsXml extends Quote
{

    /**
     * Export coupon codes as excel xml file
     *
     * @return ResponseInterface|null
     * @throws \Exception
     */
    public function execute()
    {
        $this->_initRule();
        $rule = $this->_coreRegistry->registry(RegistryConstants::CURRENT_SALES_RULE);
        if ($rule->getId()) {
            $fileName = 'coupon_codes.xml';
            $content = $this->_view->getLayout()->createBlock(
                Grid::class
            )->getExcelFile(
                $fileName
            );
            return $this->_fileFactory->create($fileName, $content, DirectoryList::VAR_DIR);
        }

        $this->_redirect('sales_rule/*/detail', ['_current' => true]);
    }
}
